<?php
/*
  $Id: headertags_seo_db_handler.php, v 3.0 by Jack_mcs

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce
  Portions Copyright 2009 oscommerce-solution.com

  Released under the GNU General Public License
  
  **********************************************************************
  Run this script to install, update or delete Header Tags SEO in 
  the database. Use this url to execute the script. The code will 
  determine what to do and provide options.
  
  http://....com/header_tags_seo_db_handler.php
  
  **********************************************************************  
*/

  require('includes/application_top.php');  
 
  define('THIS_ADDON', 'Header Tags SEO');
  define('THIS_ADDON_DESCRIPTION', 'Server wide settings for ' . THIS_ADDON);
  define('THIS_FILE', 'headertags_seo_db_handler_hybrid.php');
  define('THIS_FORM', 'headertags_seo_db_handler_hybrid');  
  
  $do_delete = (isset($_GET['delete']) ? true : false);
  $do_reset  = (isset($_GET['reset'])  ? true : false);
 
  if (isset($_POST['action']) && $_POST['action'] == 'process') {
      if (isset($_POST['delete'])) {
          $do_delete = true;
      } else if (isset($_POST['reset'])) {
          $do_reset = true;          
      } else if (isset($_POST['exit'])) {   
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto'])) {          //end of run - just go to home page
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto_delete'])) {   //end of run - just go to home page after deleting this file
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));          
      } else if (isset($_POST['goto_install'])) {   //fall through like a new run
      
      } else {  //catch-all
          unlink(THIS_FILE);      
          tep_redirect(tep_href_link('index.php'));
      }    
  }  
 
  $cfg_group_id = 0;
  $db_query = tep_db_query("select configuration_group_id from configuration_group where configuration_group_title = '" . THIS_ADDON . "'");
  if (tep_db_num_rows($db_query)) {    
      if ($do_delete) {
          $db = tep_db_fetch_array($db_query);          
          tep_db_query("DELETE FROM configuration_group WHERE configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");
          tep_db_query("DELETE FROM configuration WHERE configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");
          tep_db_query("DROP TABLE IF EXISTS headertags_cache;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_default;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_silo;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_keywords;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_search;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_social;"); 
          tep_db_query("DROP TABLE IF EXISTS headertags_ip_tracker;"); 
          
          $db_query = tep_db_query("show columns FROM `categories_description` where field like '%htc%'");
          while ($db = tep_db_fetch_array($db_query)) {
              tep_db_query("ALTER TABLE categories_description DROP `" . $db['Field'] . "`");
          }   
          $db_query = tep_db_query("show columns FROM `manufacturers_info` where field like '%htc%'");
          while ($db = tep_db_fetch_array($db_query)) {
              tep_db_query("ALTER TABLE manufacturers_info DROP `" . $db['Field'] . "`");
          }          
          $db_query = tep_db_query("show columns FROM `products_description` where field like 'products_head_%'");
          while ($db = tep_db_fetch_array($db_query)) {
              tep_db_query("ALTER TABLE products_description DROP `" . $db['Field'] . "`");
          }         
                                                 
      } else if ($do_reset) {
          $db = tep_db_fetch_array($db_query);
          $cfg_group_id = (int)$db['configuration_group_id'];   
          tep_db_query("delete from configuration where configuration_group_id = '" . (int)$db['configuration_group_id'] . "'");   
          
      } else {
          echo 'Looks like ' . THIS_ADDON . ' is already installed.<br>';
          echo 'Choose one of the following options.<br><br>';
         
          echo tep_draw_form('begin', THIS_FILE, 'post') . tep_hide_session_id() . tep_draw_hidden_field('action', 'process'); ?>
          <div style="padding-bottom:10px"><input type="submit" name="delete" value="Reload This Page and Set Delete Option"></div>
          <div style="padding-bottom:10px"><input type="submit" name="reset" value="Reload This Page and Set Reset Option"></div>
          <div style="padding-bottom:10px"><input type="submit" name="exit" value="Go To Home Page AFTER deleting this file"></div>
          </form> 
          <?php
         exit;
      }
  } 
  
  $db_sql_array = array(); 
  if ( ! $do_delete ) {  //only new runs and resets
      if ($cfg_group_id == 0) {
          $db_check_query = tep_db_query("select max(configuration_group_id) as id from configuration_group ");
          $max = tep_db_fetch_array($db_check_query);
          $cfg_group_id = $max['id'] + 1;
          tep_db_query("insert into configuration_group (configuration_group_id, configuration_group_title, configuration_group_description, sort_order, visible ) VALUES ('" . $cfg_group_id . "', '" . THIS_ADDON . "', '" . THIS_ADDON_DESCRIPTION . "', '" . (int)$cfg_group_id . "' , '1')");
      } 
    
      /**** BEGIN CONFIGURATION SECTION ****/
      $fields = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added, use_function ";
      $fields_short = " configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added ";
      $sortID = 1;
      
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('Automatically Add New Pages', 'HEADER_TAGS_AUTO_ADD_PAGES', 'True', '<center><b><h2>Header Tags SEO</h2><i>Developed by:</i><br>Jack York @ Oscommerce Solution<br><a href=\"\/\/oscommerce-solution.com\//check_unreleased_updates.php?id=3.3.6&name=HeaderTagsSEO\" target=\"_blank\">Check Updates</a></b></center><br>Adds any new pages in Page Control', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('Breadcrumb Model Override', 'HEADER_TAGS_BREADCRUMB_MODEL_OVERRIDE', 'False', 'Force the breadrumb to use the model field for the breadcrumb trail.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('ByPass New Pages Check', 'HEADER_TAGS_BYPASS_ISTEMPLATE', 'False', 'If enabled, all files in the root will be added to the list in Page Control - only use if needed<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";

      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('Canonical Path', 'HEADER_TAGS_CANONICAL_PATH', 'full', 'Canonical url will use all of the ID\'s in the url or just the last one.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'full\', \'last\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('Check for Missing Tags', 'HEADER_TAGS_CHECK_TAGS', 'True', 'Check to see if any products, categories or manufacturers contain empty meta tag fields<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";

      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Category Parents in Title and Tags</font>', 'HEADER_TAGS_ADD_CATEGORY_PARENTS', 'Standard', 'Adds all categories in the current path (Full), all immediate categories if the product is in more than one category (Duplicate) or only the immediate category (Standard). These settings only work if the Category checkbox is enabled in Page Control.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(''Full Category Path'', ''Duplicate Categories'', ''Standard''), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('<font color=purple>Display Category Short Description</font>', 'HEADER_TAGS_DISPLAY_CATEGORY_SHORT_DESCRIPTION', 'Off', 'If a number is entered, that many characters of the category description will be displayed under the category name on the category listing page. <br><br>Leave blank to display all of the text (not recommended). <br><br>Enter \'Off\' to disable this option.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Column Box</font>', 'HEADER_TAGS_DISPLAY_COLUMN_BOX', 'False', 'Display product box in column while on product page<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Currently Viewing</font>', 'HEADER_TAGS_DISPLAY_CURRENTLY_VIEWING', 'True', 'Display a link near the bottom of the product page.<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Help Popups</font>', 'HEADER_TAGS_DISPLAY_HELP_POPUPS', 'True', 'Display short popup messages that describes a feature<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Disable Permission Warning</font>', 'HEADER_TAGS_DIABLE_PERMISSION_WARNING', 'False', 'Prevent the warning that appears if the permissions for the includes/header_tags.php file appear to be incoorect.<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display See More</font>', 'HEADER_TAGS_DISPLAY_SEE_MORE', 'short', 'Display see more on the category and product listing pages. This option can be set as:<br><br>off - do not show see more link<br>short - link just shows see more<br>full - link shows see more with item name', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'off\', \'short\', \'full\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Silo Links</font>', 'HEADER_TAGS_DISPLAY_SILO_BOX', 'False', 'Display a box displaying links based on the settings in Silo Control<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Social Bookmark</font>', 'HEADER_TAGS_DISPLAY_SOCIAL_BOOKMARKS', 'True', 'Display social bookmarks on the product page<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=purple>Display Tag Cloud</font>', 'HEADER_TAGS_DISPLAY_TAG_CLOUD', 'False', 'Display the Tag Cloud infobox<br>(True=on False=off)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";

      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable Additional Words</font>', 'HEADER_TAGS_ENABLE_ADDITIONAL_WORDS', 'False', 'If True, text will be shown on the product page that lists any additional words entered for that product. If no words are entered, nothing will be displayed.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable AutoFill - Listing Text</font>', 'HEADER_TAGS_ENABLE_AUTOFILL_LISTING_TEXT', 'False', 'If True, text will be shown on the product listing page automatically. If false, the text only shows if the field has text in it.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable Cache</font>', 'HEADER_TAGS_ENABLE_CACHE', 'None', 'Enables cache for Header Tags.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'None\', \'Normal\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable an HTML Editor</font>', 'HEADER_TAGS_ENABLE_HTML_EDITOR', 'No Editor', 'Use an HTML editor, if selected. !!! Warning !!! The selected editor must be installed for it to work!!!)', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'CKEditor\', \'FCKEditor\', \'TinyMCE\', \'No Editor\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable HTML Editor for Category Descriptions</font>', 'HEADER_TAGS_ENABLE_EDITOR_CATEGORIES', 'False', 'Enables the selected HTML editor for the categories description box. The editor must be installed for this to work.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable HTML Editor for Manufacturer Descriptions</font>', 'HEADER_TAGS_ENABLE_EDITOR_MANUFACTURERS', 'False', 'Enables the selected HTML editor for the manufacturer description box. The editor must be installed and enabled for this to work.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable HTML Editor for Products Descriptions</font>', 'HEADER_TAGS_ENABLE_EDITOR_PRODUCTS', 'False', 'Enables the selected HTML editor for the products description box. The editor must be installed for this to work.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable HTML Editor for Product Listing text</font>', 'HEADER_TAGS_ENABLE_EDITOR_LISTING_TEXT', 'False', 'Enables the selected HTML editor for the Header Tags text on the product listing page. The editor must be installed for this to work.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable HTML Editor for Product Sub Text</font>', 'HEADER_TAGS_ENABLE_EDITOR_SUB_TEXT', 'False', 'Enables the selected HTML editor for the sub text on the products page. The editor must be installed for this to work.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable IP Tracking</font>', 'HEADER_TAGS_ENABLE_IP_TRACKING', 'True', 'If True, the IP of anyone using the site search function will be recorded and displayed for display in the keyword tool. Set to false if it violates your countries rules.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields . ") VALUES ('<font color=blue>Enable Keyword Meta Tag</font>', 'HEADER_TAGS_ENABLE_KEYWORD_METATAG', 'Metatag', 'Keywords can be shown in a metatag, just used for highlighting, both or none. If the keyword highlighter option is set, then this has to be set to Highlight or Both.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'Metatag\', \'Highlight\', \'Both\', \'Off\'),', now(), NULL)";
      
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Keyword Density Range', 'HEADER_TAGS_KEYWORD_DENSITY_RANGE', '0.02,0.06', 'Set the limits for the keyword density use to dynamically select the keywords. Enter two figures, separated by a comma.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields       . ") VALUES ('Keyword Highlighter', 'HEADER_TAGS_KEYWORD_HIGHLIGHTER', 'No Highlighting', 'Bold any keywords found on the page.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'No Highlighting\', \'Highlight Full Words Only\', \'Highlight Individual Words\'),', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Position Domain', 'HEADER_TAGS_POSITION_DOMAIN', '', 'Set the domain name to be used in the keyword position checking code, like www.domain_name.com or domain_name.com/shop.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Position Page Count', 'HEADER_TAGS_POSITION_PAGE_COUNT', '2', 'Set the number of pages to search when checking keyword positions (10 urls per page).', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Separator - Description', 'HEADER_TAGS_SEPARATOR_DESCRIPTION', '-', 'Set the separator to be used for the description (and titles and logo).', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Separator - Keywords', 'HEADER_TAGS_SEPARATOR_KEYWORD', ',', 'Set the separator to be used for the keywords.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields .       ") VALUES ('Search Keywords', 'HEADER_TAGS_SEARCH_KEYWORDS', 'False', 'This option allows keywords stored in the Header Tags SEO search table to be searched when a search is performed on the site.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields .       ") VALUES ('Store Keywords', 'HEADER_TAGS_STORE_KEYWORDS', 'True', 'This option stores the searched for keywords so they can be used by other parts of Header Tags, like in the Tag Cloud option.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now(), NULL)";
      $lines[] = "INSERT INTO configuration (" . $fields_short . ") VALUES ('Tag Cloud Column Count', 'HEADER_TAGS_TAG_CLOUD_COLUMN_COUNT', '8', 'Set the number of keywords to display in a row in the Tag Cloud box.', '" . $cfg_group_id . "', '" . ($sortID++). "', now())";
      $lines[] = "INSERT INTO configuration (" . $fields .       ") VALUES ('Use Item Name on Page</font>', 'HEADER_TAGS_USE_PAGE_NAME', 'False', 'If True, the title on the page will be the name of the item (category, manufacturer or product). If false, the Header Tags SEO title will be used.', '" . $cfg_group_id . "', '" . ($sortID++). "', 'tep_cfg_select_option(array(\'True\', \'False\'),', now(), NULL)";
 
      $colors = array('a' => 'blue','b' => 'maroon','e' => 'steelblue', 'm' => 'red', 'n' => 'purple');
      $letters = array('a', 'b', 'e', 'm', 'n') ;
      $ctr = 0;      
      $configuration_array = array();
      
      foreach ($lines as &$line) {
          $posStart = strpos($line, "'") + 1;
          $posStop  = strpos($line, "'", $posStart);
          $word = substr($line, $posStart, $posStop - $posStart);          
          $lgth = strlen($word);
          $char = strtolower($word[0]);
          $color = '';

          foreach ($letters as $letter) {
              if ($letter == $char) {
                  $color = $colors[$char];
                  break;
              }
          }
          $configuration_array[] = array(substr_replace($line, '<font color=' . $color . '>' . $word . '</font>', $posStart, $lgth));
      }

      $db_sql_array = array_merge($db_sql_array, $configuration_array);
      /**** END CONFIGURATION SECTION ****/
      
      /**** BEGIN CREATING THE TABLES ****/               
      $tables = array(          
                   array("CREATE TABLE IF NOT EXISTS headertags_cache (
                               title text, 
                               data text
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                               
                   array("CREATE TABLE IF NOT EXISTS headertags_default (
                               default_title varchar(64) default '' NOT NULL, 
                               default_description varchar(120) default '' NOT NULL, 
                               default_keywords varchar(255) default '' NOT NULL, 
                               default_logo_text varchar(255) default '' NOT NULL, 
                               home_page_text text default '' NOT NULL, 
                               default_logo_append_group tinyint(1) default 1 NOT NULL, 
                               default_logo_append_category tinyint(1) default 1 NOT NULL, 
                               default_logo_append_manufacturer tinyint(1) default 1 NOT NULL, 
                               default_logo_append_product tinyint(1) default 1 NOT NULL, 
                               meta_google tinyint(1) default 0 NOT NULL, 
                               meta_language tinyint(1) default 0 NOT NULL, 
                               meta_noodp tinyint(1) default 1 NOT NULL, 
                               meta_noydir tinyint(1) default 1 NOT NULL, 
                               meta_replyto tinyint(1) default 0 NOT NULL, 
                               meta_revisit tinyint(1) default 0 NOT NULL, 
                               meta_robots tinyint(1) default 0 NOT NULL, 
                               meta_unspam tinyint(1) default 0 NOT NULL, 
                               meta_canonical tinyint(1) default 1 NOT NULL, 
                               meta_og tinyint(1) default 1 NOT NULL, 
                               language_id int DEFAULT 1 NOT NULL, 
                               PRIMARY KEY (default_title, language_id)
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                             
                   array("CREATE TABLE IF NOT EXISTS headertags (
                               page_name varchar(64) default '' NOT NULL, 
                               page_title varchar(120) default '' NOT NULL, 
                               page_description varchar(255) default '' NOT NULL, 
                               page_keywords varchar(255) default '' NOT NULL, 
                               page_logo varchar(255) default '' NOT NULL, 
                               page_logo_1 varchar(255) default '' NOT NULL, 
                               page_logo_2 varchar(255) default '' NOT NULL, 
                               page_logo_3 varchar(255) default '' NOT NULL, 
                               page_logo_4 varchar(255) default '' NOT NULL, 
                               append_default_title tinyint(1) default 0 NOT NULL, 
                               append_default_description tinyint(1) default 0 NOT NULL, 
                               append_default_keywords tinyint(1) default 0 NOT NULL, 
                               append_default_logo tinyint(1) default 0 NOT NULL, 
                               append_category tinyint(1) default 0 NOT NULL, 
                               append_manufacturer tinyint(1) default 0 NOT NULL, 
                               append_model tinyint(1) default 0 NOT NULL, 
                               append_product tinyint(1) default 1 NOT NULL, 
                               append_root tinyint(1) default 1 NOT NULL, 
                               sortorder_title tinyint(2) default 0 NOT NULL, 
                               sortorder_description tinyint(2) default 0 NOT NULL, 
                               sortorder_keywords tinyint(2) default 0 NOT NULL, 
                               sortorder_logo tinyint(2) default 0 NOT NULL, 
                               sortorder_logo_1 tinyint(2) default 0 NOT NULL, 
                               sortorder_logo_2 tinyint(2) default 0 NOT NULL, 
                               sortorder_logo_3 tinyint(2) default 0 NOT NULL, 
                               sortorder_logo_4 tinyint(2) default 0 NOT NULL, 
                               sortorder_category tinyint(2) default 0 NOT NULL, 
                               sortorder_manufacturer tinyint(2) default 0 NOT NULL, 
                               sortorder_model tinyint(2) default 0 NOT NULL, 
                               sortorder_product tinyint(2) default 10 NOT NULL, 
                               sortorder_root tinyint(2) default 1 NOT NULL, 
                               sortorder_root_1 tinyint(2) default 1 NOT NULL, 
                               sortorder_root_2 tinyint(2) default 1 NOT NULL, 
                               sortorder_root_3 tinyint(2) default 1 NOT NULL, 
                               sortorder_root_4 tinyint(2) default 1 NOT NULL, 
                               language_id int DEFAULT 1 NOT NULL, 
                               KEY idx_page_name (page_name), 
                               KEY idx_page_description (page_description), 
                               KEY idx_page_keywords (page_keywords) 
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                             
                   array("CREATE TABLE IF NOT EXISTS headertags_silo (
                               category_id int NOT NULL DEFAULT '0', 
                               box_heading VARCHAR (60) NOT NULL, 
                               is_disabled TINYINT (1) DEFAULT 0 NOT NULL,
                               max_links int DEFAULT '6' NOT NULL, 
                               sorton TINYINT (2) DEFAULT 0 NOT NULL, 
                               language_id int DEFAULT '1' NOT NULL, 
                               PRIMARY KEY ( category_id, language_id )
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                              
                   array("CREATE TABLE IF NOT EXISTS headertags_keywords (
                               id int(11) NOT NULL AUTO_INCREMENT, 
                               keyword varchar(120) NOT NULL DEFAULT '', 
                               counter int(11) NOT NULL DEFAULT '1', 
                               last_search datetime NOT NULL DEFAULT '0000-00-00 00:00:00', 
                               google_last_position tinyint(4) NOT NULL DEFAULT '0', 
                               google_date_position_check datetime NOT NULL DEFAULT '0000-00-00 00:00:00', 
                               found TINYINT( 1 ) NOT NULL DEFAULT 0, 
                               ip_number INT( 64 ) UNSIGNED NOT NULL DEFAULT 0, 
                               language_id int(11) NOT NULL DEFAULT '1', 
                               PRIMARY KEY (id), KEY keyword (keyword), 
                               KEY found (found)  
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                             
                   array("CREATE TABLE IF NOT EXISTS headertags_search (
                               product_id INT( 11 ) NOT NULL, 
                               keyword VARCHAR( 64 ) NOT NULL, 
                               language_id INT( 11 ) NOT NULL, 
                               KEY keyword (keyword)
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                             
                   array("CREATE TABLE IF NOT EXISTS headertags_social (
                               unique_id INT ( 4 ) NOT NULL AUTO_INCREMENT , 
                               section VARCHAR( 48 ) NOT NULL , 
                               groupname VARCHAR (24 ) NOT NULL, url VARCHAR ( 255 ) NOT NULL, data TEXT NOT NULL , 
                               KEY idx (unique_id), 
                               KEY idx_section (section)
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;"),
                             
                   array("CREATE TABLE IF NOT EXISTS headertags_ip_tracker (
                               ip_number INT( 64 ) UNSIGNED NOT NULL , 
                               source TINYINT ( 4 ) NOT NULL , 
                               id_reference INT ( 11 ) NOT NULL, 
                               date_added datetime NOT NULL , 
                               KEY idx_ip_number (ip_number), 
                               KEY idx_date_added (date_added)
                             ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;")
                            );
 
      $db_sql_array = array_merge($db_sql_array, $tables);
      /**** END CREATING THE TABLES ****/ 
  }

  if (! $do_delete) {  
      /**** BEGIN TABLE INSERTIONS ****/  
      $table_inserts = array();    
      $table_inserts[] = array("TRUNCATE headertags_default");      
      $table_inserts[] = array("TRUNCATE headertags");  

      $languages_query = tep_db_query("select languages_id from languages order by sort_order");
      while ($languages = tep_db_fetch_array($languages_query)) {      
          $table_inserts[] = array("INSERT INTO headertags_default VALUES ('Default title', 'Default description', 'Default Keywords', 'Default Logo Text', '','0','0','0','0','0','0','1','1','0','0','0','0', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('index.php', 'Replace me in Page Control under index.php - oscommerce-solution.com', 'Replace me in Page Control under index.php - oscommerce-solution.com', 'Replace me in Page Control under index.php - oscommerce-solution.com', 'Replace me in Page Control under index.php - oscommerce-solution.com', '', '', '', '', '0', '0', '0', '0', '1', '0', '0', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '2', '0', '0', '10', '0', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('product_info.php', '', '', '', '', '', '', '', '', '0', '0', '0', '0', '0', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0',  '10', '1', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('product_reviews.php', '', '', '', '', '', '', '', '', '0', '0', '0', '0', '0', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '10', '1', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('product_reviews_info.php', '', '', '', '', '', '', '', '', '0', '0', '0', '0', '0', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '10', '1', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('product_reviews_write.php', '', '', '', '', '', '', '', '', '0', '0', '0', '0', '0', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '10', '1', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
          $table_inserts[] = array("INSERT INTO headertags VALUES ('specials.php', 'specials', 'specials', 'specials', 'Specials', '', '', '', '', '0', '0', '0', '0', '0', '0', '0', '1', '1', '0', '0', '0', '0', '0', '0', '0', '0', '0','0', '0', '10', '1', '1', '1', '1', '1', '" . $languages['languages_id'] . "')");
      }
      
      $db_sql_array = array_merge($db_sql_array, $table_inserts);
      /**** END TABLE_INSERTS ****/ 
      
      /**** BEGIN SOCIAL ICONS ****/  
      $social_icons_array = array();
      
      $social_icons_array[] = array('TRUNCATE headertags_social');
      $social_icons_array[] = array("INSERT INTO headertags_social (unique_id, section, groupname, url, data) VALUES
        ('1','socialicons', 'blogspot', 'https://blogspot.com/submit?phase=2&url=URL&TITLE', '16x16'),
        ('2','socialicons', 'digg', 'https://digg.com/submit?phase=2&url=URL&TITLE', '16x16'),
        ('3','socialicons', 'facebook', 'https://www.facebook.com/share.php?u=URL&TITLE', '16x16'),
        ('4','socialicons', 'google', 'https://www.google.com/bookmarks/mark?op=edit&bkmk=URL&TITLE', '16x16'),
        ('5','socialicons', 'pintrest', 'https://pinterest.com/pin/create/button/?url=URL&TITLE', '16x16'),
        ('6','socialicons', 'reddit', 'https://reddit.com/submit?url=URL&TITLE', '16x16'),
        ('7', 'socialicons', 'linkedin', 'https://www.linkedin.com/shareArticle?mini=true&url=&title=TITLE=&source=URL', '16x16'),
        ('8', 'socialicons', 'mix', 'https://mix.com/submit?url=URL&TITLE', '16x16'),
        ('9', 'socialicons', 'newsvine', 'https://www.newsvine.com/_tools/seed&amp;save?u=URL&h=TITLE', '16x16'),
        ('10', 'socialicons', 'twitter', 'https://twitter.com/home?status=URL&TITLE', '16x16')
        ");

      $db_sql_array = array_merge($db_sql_array, $social_icons_array);
      /**** END SOCIAL ICONS ****/         
  }    
      /**** BEGIN UPDATES FOR PREVIOUS VERSIONS ****/        
      if ( $do_reset ) { 
          $updates = array(); 
          
          $db_sql_array = array_merge($db_sql_array, $updates);
      }      
      /**** END UPDATES FOR PREVIOUS VERSIONS ****/     


      /**** BEGIN NON-HEADER TAS SEO CHANGES ****/    
      $non_hts_array = array();
      $field_array = array();
      //$db_query = tep_db_query("show columns FROM `categories_description` where Field like '%htc%'");
      $db_query = tep_db_query("show columns FROM `categories_description`");
      while ($db = tep_db_fetch_array($db_query)) {
          $field_array[] = $db['Field'];
      }

      if (! in_array('categories_seo_keywords', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE categories_description ADD categories_seo_keywords VARCHAR(255) NULL;");
      }    
      if (! in_array('categories_htc_title_tag_alt', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE categories_description ADD categories_htc_title_tag_alt VARCHAR(80) NULL;");
      }    
      if (! in_array('categories_htc_title_tag_url', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE categories_description ADD categories_htc_title_tag_url VARCHAR(80) NULL;");
      }    
      if (! in_array('categories_htc_breadcrumb_text', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE categories_description ADD categories_htc_breadcrumb_text VARCHAR(160) NULL;");
      }    
          
      $field_array = array();
      //$db_query = tep_db_query("show columns FROM `manufacturers_info` where field like '%htc%'");
      $db_query = tep_db_query("show columns FROM `manufacturers_info`");
      while ($db = tep_db_fetch_array($db_query)) {
          $field_array[] = $db['Field'];
      }      
      if (! in_array('manufacturers_seo_keywords', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE manufacturers_info ADD manufacturers_seo_keywords VARCHAR(255) NULL;");
      }                
      if (! in_array('manufacturers_htc_title_tag_alt', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE manufacturers_info ADD manufacturers_htc_title_tag_alt VARCHAR(80) NULL;");
      }          
      if (! in_array('manufacturers_htc_title_tag_url', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE manufacturers_info ADD manufacturers_htc_title_tag_url VARCHAR(80) NULL;");
      }          
      if (! in_array('manufacturers_htc_breadcrumb_text', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE manufacturers_info ADD manufacturers_htc_breadcrumb_text VARCHAR(80) NULL;");
      }          

      $field_array = array();
      //$db_query = tep_db_query("show columns FROM `products_description` where field like 'products_head_%'");
      $db_query = tep_db_query("show columns FROM `products_description`");
      while ($db = tep_db_fetch_array($db_query)) {
          $field_array[] = $db['Field'];
      }  
      if (! in_array('products_seo_keywords', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_seo_keywords VARCHAR(255) NULL;");
      }               
      if (! in_array('products_head_title_tag_alt', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_title_tag_alt VARCHAR(80) NULL;");
      }         
      if (! in_array('products_head_title_tag_url', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_title_tag_url VARCHAR(80) NULL;");
      }         
      if (! in_array('products_head_listing_text', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_listing_text TEXT NULL;");
      }         
      if (! in_array('products_head_sub_text', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_sub_text TEXT NULL;");
      }         
      if (! in_array('products_head_breadcrumb_text', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_breadcrumb_text VARCHAR(80) NULL;");
      }         
      if (! in_array('products_head_additional_words', $field_array)) { 
          $non_hts_array[] = array("ALTER TABLE products_description ADD products_head_additional_words VARCHAR(256) NULL;");
      }         
                  
      $db_sql_array = array_merge($db_sql_array, $non_hts_array);              
      /**** END NON-HEADER TAS SEO CHANGES ****/   

      
  // APPLY THE CHANGES
  foreach ($db_sql_array as $sql_array) {
      foreach ($sql_array as $value) {
          if (tep_db_query($value) == false) {
              echo 'An error has occurred while inserting the settings. Aborting!';
              exit;
          }
      }  
  }
?>
<div class="pageHeading"><?php echo THIS_ADDON . ' Database Handler'; ?></div>
<div style="padding:10px 0">
<?php
  if ($do_delete) {
      echo 'Database successfully Removed for ' . THIS_ADDON , '!!!';
  } else if ($do_reset) {
      echo 'Database successfully Updated for ' . THIS_ADDON , '!!!';
  } else {
      echo 'Database successfully Installed for ' . THIS_ADDON , '!!!';
  }
?>
</div>

<?php echo tep_draw_form(THIS_FORM, THIS_FILE, 'post') . tep_hide_session_id() . tep_draw_hidden_field('action', 'process'); ?>

  <?php if ($do_delete) { ?>
  <div style="padding-bottom:10px"><input type="submit" name="goto_install" value="Install Again"></div>
  <?php } ?>
  <div style="padding-bottom:10px"><input type="submit" name="goto_delete" value="Go To Home Page AFTER deleting this file (recommended)"></div>
  <div style="padding-bottom:10px"><input type="submit" name="goto" value="Go To Home Page"></div>
</form> 


