<?php
 /*
  Copyright (c) 2019, Jack York
  All rights reserved.

  Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

  1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

  2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

  3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
class hook_shop_sitewide_header_tags_seo_tag_cloud {
 
   var $str = null; 
   
   function listen_injectAfterFooter() { 
    
       if (HEADER_TAGS_DISPLAY_TAG_CLOUD == 'true') {
           global $languages_id;
           
           include_once('includes/functions/header_tags.php');
           $htsTagsArray = array();
           $hts_tags_query = tep_db_query("select keyword, counter from headertags_keywords where keyword is not null and keyword != '' and found = 1 and language_id = " . (int)$languages_id . " ORDER BY counter DESC LIMIT 20");   
           
          
           if (tep_db_num_rows($hts_tags_query)) {
               $maximum = 0;  // $maximum is the highest counter for a search term
               while ($hts_tags = tep_db_fetch_array($hts_tags_query)) {
                   if ($hts_tags['counter'] > $maximum) {
                       $maximum = $hts_tags['counter'];
                   }
                   $htsTagsArray[] = array('keyword' => $hts_tags['keyword'], 'counter' => $hts_tags['counter']);
               }
               shuffle($htsTagsArray);

               $class = '';
               $colCtr = '';
               $content = '<div id="tagcloud"><div style="text-align:center;">';

               foreach ($htsTagsArray as $kword) {
                   if (! tep_not_null(($hstLink = GetHTSTagCloudLink($kword['keyword'], $languages_id)))) {
                       continue;
                   }
                  
                   $percent = floor(($kword['counter'] / $maximum) * 100); // determine the popularity of this term as a percentage

                   switch (true) {  // determine the size for this term based on the percentage
                       case $percent >= 80: $class = 'largest';  break;
                       case $percent >= 60: $class = 'large';    break;
                       case $percent >= 40: $class = 'medium';   break;
                       case $percent >= 20: $class = 'small';    break;
                       default:             $class = 'smallest'; break;
                   }  

                   $content .= '<span class="' . $class . '"><a class="' . $class . '" href="' . $hstLink . '">' . ucwords(stripslashes($kword['keyword'])) . '</a></span>&nbsp;';
                   $colCtr++;

                   if ($colCtr >= HEADER_TAGS_TAG_CLOUD_COLUMN_COUNT) {
                       $colCtr = 0;
                       $content .= '</div><div style="text-align:center;">';
                   }
               }
               $content .= '</div>';
               
               $str = '<div id="hts_footer">';
               $str .= '<span class="hts_footer_title">' .  BOX_HEADING_HEADERTAGS_TAGCLOUD . '</span>' . $content . '</div>';
               $str .= '</div>';
           }              
       }
       return $str; 
   }        
}
