<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2020 osCommerce

  Released under the GNU General Public License
*/

  class cm_pi_description_headertags extends abstract_executable_module {

    const CONFIG_KEY_BASE = 'MODULE_CONTENT_PI_DESCRIPTION_HEADERTAGS';

    public function __construct() {
      parent::__construct(__FILE__);
    }

    function execute() {
      global $product_info, $header_tags_array;

      $content_width = (int)MODULE_CONTENT_PI_DESCRIPTION_HEADERTAGSCONTENT_WIDTH;

      $product_description = HTS_Highlight(stripslashes($product_info['products_description']), $header_tags_array['keywords']);

      $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
      include 'includes/modules/content/cm_template.php';
    }

    protected function get_parameters() {
      return [
        'MODULE_CONTENT_PI_DESCRIPTION_HEADERTAGSSTATUS' => [
          'title' => 'Enable Description Module',
          'value' => 'True',
          'desc' => 'Should this module be shown on the product info page?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        'MODULE_CONTENT_PI_DESCRIPTION_HEADERTAGSCONTENT_WIDTH' => [
          'title' => 'Content Width',
          'value' => '8',
          'desc' => 'What width container should the content be shown in?',
          'set_func' => "tep_cfg_select_option(['12', '11', '10', '9', '8', '7', '6', '5', '4', '3', '2', '1'], ",
        ],
        'MODULE_CONTENT_PI_DESCRIPTION_HEADERTAGSSORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '60',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

  }
